"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skip = exports.take = exports.isObjectEmpty = exports.defaultPrismaStringFilter = exports.defaultOptions = exports.defaultQueryFields = void 0;
/* A type definition for the defaultQueryFields object. */
exports.defaultQueryFields = {
    limit: 15,
    page: 1,
    sort: 'createdAt',
    select: '',
    include: '',
    filter: '',
};
/* Defining the defaultOptions object. */
exports.defaultOptions = {
    currentPage: 1,
    perPage: 15,
};
/* Defining the defaultPrismaStringFilter constant. */
exports.defaultPrismaStringFilter = [
    'equals',
    'in',
    'notIn',
    'lt',
    'lte',
    'gt',
    'gte',
    'contains',
    'startsWith',
    'endsWith',
    'mode',
    'not',
];
/**
 * It checks if the object is not null, has no keys, and is an object
 * @param {object} obj - object - The object to check if it's empty.
 */
const isObjectEmpty = (obj) => {
    return obj && Object.keys(obj).length === 0 && obj.constructor === Object;
};
exports.isObjectEmpty = isObjectEmpty;
/* It's a shorthand for `export const take = (defaultOptions.perPage * 1) || 50;` */
exports.take = exports.defaultOptions.perPage * 1 || 50;
/* It's a shorthand for `export const skip = ((defaultOptions.currentPage * 1 || 1) - 1) *
(defaultOptions.perPage * 1 || 50);` */
exports.skip = ((exports.defaultOptions.currentPage * 1 || 1) - 1) * (exports.defaultOptions.perPage * 1 || 50);
//# sourceMappingURL=query-builder.constant.js.map