import type { ParsedQs } from "qs";
/**
 * It returns true if the value passed to it is an object, and false if it's not
 * @param {any} val - any
 * @returns The constructor of the object.
 */
export declare const isObject: (val: any) => boolean;
/**
 * If the value is not a number, then it's not a number.
 * @param {any} val - any - The value to check
 * @returns A function that takes a parameter and returns a boolean.
 */
export declare const isNumber: (val: any) => boolean;
/**
 * It returns true if the value is a string that is either 'true' or 'false'
 * @param {any} val - any
 * @returns A function that takes a parameter and returns a boolean.
 */
export declare const isBoolean: (val: any) => boolean;
/**
 * If the value is an array, return true, otherwise return false.
 * @param {any} val - any
 * @returns A function that takes a parameter and returns a boolean.
 */
export declare const isArray: (val: any) => boolean;
/**
 * It takes an object, and returns an object with the same keys, but with the values parsed
 * @param {ParsedQs} obj - ParsedQs - The object to parse.
 * @returns An object with the key and value of the parsed object.
 */
export declare const parseObject: (obj: ParsedQs) => {};
/**
 * It takes an array of strings and returns an array of objects.
 * @param {string | any[]} arr - string | any[]
 * @returns An array of parsed values.
 */
export declare const parseArray: (arr: string | any[]) => any[];
/**
 * It takes a value, converts it to a number, and returns it.
 * @param {any} val - any - The value to be parsed.
 * @returns A function that takes a parameter and returns a number.
 */
export declare const parseNumber: (val: any) => number;
/**
 * It returns true if the value is the string 'true', otherwise it returns false
 * @param {any} val - any - The value to parse.
 * @returns A function that takes a parameter and returns a boolean.
 */
export declare const parseBoolean: (val: any) => boolean;
/**
 * If the value is a boolean, array, object, or number, parse it. Otherwise, return the value.
 * @param {any} val - any
 * @returns the value of the variable val.
 */
export declare const parseValue: (val: any) => any;
/**
 * It takes a query object, parses it, and then returns a new object with the parsed values
 * @returns A function that takes in a request and a response and a next function.
 */
export declare const queryParseMiddleware: () => (req: {
    query: ParsedQs;
}, _res: any, next: () => void) => void;
